// -*- mode: C++; c-indent-level: 4; c-basic-offset: 4; indent-tabs-mode: nil; -*-
//
// blockpfgaussianopt.h: Rcpp integration of SMC library -- Block PF Gaussian
//
// Copyright (C) 2012         Dirk Eddelbuettel and Adam Johansen
// Copyright (C) 2017         Dirk Eddelbuettel, Adam Johansen and Leah South
//
// This file is part of RcppSMC.
//
// RcppSMC is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
//
// RcppSMC is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with RcppSMC.  If not, see <http://www.gnu.org/licenses/>.

#include "smctc.h"

namespace BSPFG {    
    //A derived class for the moves
    class BSPFG_move:
    public smc::moveset<arma::vec,smc::nullParams>
    {
    public:
	
        void pfInitialise(arma::vec & value, double & logweight, smc::nullParams & param);
        void pfMove(long lTime, arma::vec & value, double & logweight, smc::nullParams & param);
		
        ~BSPFG_move() {};

    };
	
	smc::moveset<arma::vec,smc::nullParams>* myMove;
}
